#!/bin/sh
KEY=$( /home/lirc_key )
ORIGINAL_VERSION=original
LIBS=/var/lib/usrlib.tar.bz2

# Check for compressed libs
if [ -f $LIBS ]
then
	cd /
	md5sum -c $LIBS.md5
	if [ $? -eq 0 ]
	then
		tar xjf $LIBS
		rm $LIBS*
	fi
fi

# Show start indicator
/home/set_string '-   '

# Check /lifia link
if [ ! -e /lifia ]
then
	ln -s /newtronic/$ORIGINAL_VERSION /lifia
fi

/home/set_string '--  '

# Process fatalities after of led with version
if [ -n "$(echo $KEY | grep 0x80010180 )" ]
then
	# Factory settings
	echo "Factory settings"
	rm /lifia/zapper/core.conf
fi

/home/set_string '--- '

if [ -n "$(echo $KEY | grep 0x80010181 )" ]
then
	# Back to original version
	echo "Back to original version"
	rm /lifia
	ln -s /newtronic/$ORIGINAL_VERSION /lifia
	rm /lifia/zapper/core.conf
fi

/home/set_string '----'

: ${BUILD_PATH="/lifia/"}
echo "Loading firmware from ${BUILD_PATH}"

echo "Initializing firmware ..."
. ${BUILD_PATH}/bin/init.sh

while [ 1 ]; do                                                                 
	NEED_UPDATE=0
	LAUNCH_WEB_BROWSER=0
	. ${BUILD_PATH}/bin/start.sh
	if [ ${NEED_UPDATE} -eq 1 ]
	then
		echo Performing firmware decompression
		/home/updateFW.sh
	fi
	if [ ${LAUNCH_WEB_BROWSER} -eq 1 ]
	then
		echo Launching Web Browser
		/home/splash/video_init -i -s 7
		WebkitGtkLauncher
	fi
done

echo "Shutdown firmware ..."

