#!/bin/sh
UPDATE_PATH=$ROOTFS/ramdisk/update/
NEW_UPDATE_PACK=$(ls $UPDATE_PATH | head -n 1 )

cd $ROOTFS/newtronic/
tar tzf $UPDATE_PATH$NEW_UPDATE_PACK > /dev/null
if [ $? -eq 0 ] 
then    
	echo Removing symlink
	rm $ROOTFS/lifia
	sync

	echo Removing old firmwares
	rm -rf $ROOTFS/newtronic/firm*
	sync

	echo Installing new update
	tar xzf $UPDATE_PATH$NEW_UPDATE_PACK
	if [ $? -eq 0 ] 
	then    
		NEW_UPDATE_DIR=$( ls $ROOTFS/newtronic/ | grep -v original | head -n 1 )
		NEW_FIRMWARE=$ROOTFS/newtronic/$NEW_UPDATE_DIR

		echo Doing post install
		if [ -x $NEW_FIRMWARE/post_install.sh ]
		then
			echo Executing post_install.sh
			$NEW_FIRMWARE/post_install.sh
			sync
		fi

		echo Updating symlink
		ln -s $NEW_FIRMWARE /lifia
		sync
	fi

	echo Removing old update file pack
	rm $UPDATE_PATH/$NEW_UPDATE_PACK
	sync
	reboot
	#sleeps for 1 day ;)
	sleep 1d 
fi

