
local closedCaption = textarea:new(150         -- x
                                 , 450         -- y
                                 , 420         -- w
                                 , 75          -- h
                                 , Color.Black -- Background color
                                 , ""          -- Text
                                 , 22          -- Font Size
                                 , 5           -- #Lines
                                 , Color.White -- Text color
                                 , 4           -- Margin
                                 , Alignment.vTop_hCenter) -- Alignment
wgt:setVisible(closedCaption, FALSE)
textarea:fitToTextSize(closedCaption, TRUE)
view.setClosedCaptionWidget(closedCaption)

local ccActive = false


function toggleCaption()
	local next = channel.nextSubtitle()
    if (next ~= -1) then
		ccActive = true
		view.showClosedCaption(TRUE)
	else
		ccActive = false
		view.showClosedCaption(FALSE)
	end
end

function enableCC()
	if ccActive then 
		view.showClosedCaption(TRUE)
	end
end

function disableCC()
	view.showClosedCaption(FALSE)
	view.refresh()
end

function closeCC()
	ccActive = false
	disableCC()
end

function showCaption( str )
	print( "[lua] subtitle: " .. str )
	textarea:setText(closedCaption, str)
	view.refresh()
end

