local X = 200
local Y = 200
local W = 385
local H = 165
local BUTTON_W = 75
local BUTTON_H = 36

UpdateDlg = {
	  dlg = yesnodialog:new(X, Y, W, H, Color.Black, Color.Blue, 4, BUTTON_W, BUTTON_H)
	, nav = {}
}

yesnodialog:title(UpdateDlg.dlg, "ADVERTENCIA")
yesnodialog:icon( UpdateDlg.dlg, "imgs/Confirmacion.png", 70, 61, "imgs/Confirmacion_Gris.png")
yesnodialog:text( UpdateDlg.dlg, "Hay actualizaciones disponibles\n¿Desea instalarlas?", 2)
yesnodialog:yesAction(UpdateDlg.dlg, "updateYesAction")
yesnodialog:noAction( UpdateDlg.dlg, "updateNoAction")
wgt:setVisible(UpdateDlg.dlg, FALSE)

local updatingDialog = alertdialog:new(X, Y, W, H, Color.Black, Color.Blue, 4)
alertdialog:title(updatingDialog, "ADVERTENCIA")
alertdialog:text(updatingDialog, "Actualizando...", 1)
alertdialog:icon(updatingDialog, "imgs/Confirmacion.png", 70, 61, "imgs/Confirmacion_Gris.png")

updatingBackground = window:new(0,0, canvas_w,canvas_h, Color.Gray)
wgt:setVisible(updatingBackground, FALSE)

function UpdateDlg.nav.processKeys(key)
	return wgt:processKey(UpdateDlg.dlg, key)
end

local UpdateIDQueue = {}

function updateYesAction()
	applyUpdates(1)
end

function updateNoAction() 
	applyUpdates(0) 
end

function checkUpdates()
	if (#UpdateIDQueue > 0) then
		confirmUpdate()
	end
end

function applyUpdates(b)
	print('[lua] applyUpdates('.. b ..')')
	closeDialog(UpdateDlg)
	for k,id in pairs(UpdateIDQueue) do
		if (b == 1) then
			print('[lua] accepting update '..id)
			wgt:open(updatingBackground)
			wgt:open(updatingDialog)
			view.refresh()
		else
			print('[lua] discarding update '..id)
		end
		update.apply(id,b)
	end
	UpdateIDQueue = {}
end

function UpdateDlg.onExit()
	print('[lua] UpdateDlg.onExit()')
	applyUpdates(0)
end

function canShowConfirmUpdate()
	return CurrentWindow().isRoot
end

function confirmUpdate()
	print('[lua] confirmUpdate()')
	if (canShowConfirmUpdate()) then
		print('[lua] canConfirmUpdate(), rendering dialog')
		openDialog(UpdateDlg)
	end
end

function updateReceived( updateID )
	table.insert(UpdateIDQueue, updateID)
	confirmUpdate()
end

