Page_Channels = {
	  name="Page_Channels"
	, visible=false
	, x=PageX, y=PageY
	, width=PageW, height=PageH

	, visible_columns={"channel","name", "favorite", "blocked"}
	, index_key="channelID"
	, headers={'Nro', 'Nombre del canal', 'Fav', 'Bloq'}
	, columns_sizes={61, 240, 40,40}
	, show_count=9

	, label = "CANALES"
	, icon         = "imgs/Menu-1-Canales.png"
	, selectedicon = "imgs/Menu-1-Canales_selec.png"
	, disabledicon = "imgs/Menu-1-Canales_gris.png"
	, help = "Administración de la lista de canales.\nOK = Editar   EXIT/MENU = Salir del menú"

	, channel_list = nil
	, button_set   = nil
	, btnOneSeg    = nil
	, page         = nil
	, ignoredKeys  = {}
	
	, pinRequired = {
		  dlg = nil
		, nav = {}
	}
	, confirmDelete = {
		  dlg = nil
		, nav = {}
	}
	, parental = {
		  dlg = nil
		, nav = {}
	}
	, confirmScan = {
		  dlg = nil
		, nav = {}
	}

	, scanning = false	
	, scanning_banner = {
		  window = nil
		, text   = nil
		, bar    = nil
		, NetworkCount = 0
		, CurrentNetwork = 0
		, net = ''
	}
}

require "parental"

local buttonH = 42
local buttonW = 60
local lastChannelSelected = 0

function Page_Channels.create()
	Page_Channels.page = menupage:new(0,0, PageW,PageH, 0)
	menupage:setLabel(Page_Channels.page, Page_Channels.label);
	menupage:setIcons(Page_Channels.page, Page_Channels.selectedicon, Page_Channels.disabledicon, Page_Channels.icon)
	menupage:setHelp( Page_Channels.page, Page_Channels.help)
	menupage:setBorderColors(Page_Channels.page, Color.Yellow, Color.Blue)

	Page_Channels.channel_list = list:new(PageMargin + PageBorder, PageMargin + PageBorder, PageW, PageH - buttonH)
	list:setSelected(   Page_Channels.channel_list, 0)
	list:setVisibleRows(Page_Channels.channel_list, Page_Channels.show_count);
	list:setCellWidths( Page_Channels.channel_list, Page_Channels.columns_sizes);
	list:setCellHeaders(Page_Channels.channel_list, Page_Channels.headers);

	list:mapColumn(Page_Channels.channel_list, 2, "1", "img:imgs/Canales_Favorito_Blanco.png", "img:imgs/Canales_Favorito.png")
	list:mapColumn(Page_Channels.channel_list, 3, "1", "img:imgs/Canales_Bloquear_Blanco.png", "img:imgs/Canales_Bloquear.png")

	menupage:addChild(Page_Channels.page, Page_Channels.channel_list)

-- Buttons
	Page_Channels.button_set = buttonset:new(PageMargin + PageBorder, PageH - buttonH - PageMargin - PageBorder, 354+buttonW, buttonH, Color.Black)
	buttonset:circular(Page_Channels.button_set, TRUE)
	menupage:addChild(Page_Channels.page, Page_Channels.button_set)

	-- favourite
	local btnFav = button:new(0, 0, buttonW, buttonH, Color.Blue, Color.Yellow)
	button:label(    btnFav, "Fav.")
	button:textColor(btnFav, Color.White, Color.Black)
	button:icon(     btnFav, "imgs/Canales_Favorito.png","imgs/Canales_Favorito.png", 24, 20)
	button:action(   btnFav, "favPressed")
	wgt:setHelp(     btnFav, "Marca o desmarca como favorito el canal seleccionado.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnFav, "enableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnFav)

	-- block
	local btnBloq = button:new(65, 0, buttonW, buttonH, Color.Blue, Color.Yellow)
	button:label(    btnBloq, "Bloq.")
	button:textColor(btnBloq, Color.White, Color.Black)
	button:icon(     btnBloq, "imgs/Canales_Bloquear.png","imgs/Canales_Bloquear.png", 24, 20);
	button:action(   btnBloq, "bloqPressed")
	wgt:setHelp(     btnBloq, "Bloquea o desbloquea el canal seleccionado.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
	buttonset:addButton(Page_Channels.button_set, btnBloq)

	-- delete
	local btnDel = button:new(130, 0, buttonW, buttonH, Color.Blue, Color.Yellow)
	button:label(    btnDel, "Borrar")
	button:textColor(btnDel, Color.White, Color.Black)
	button:icon(     btnDel, "imgs/Canales_Borrar.png","imgs/Canales_Borrar.png", 24, 20);
	button:action(   btnDel, "delPressed")
	wgt:setHelp(     btnDel, "Borra el canal seleccionado.\nOK = Borrar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnDel, "enableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnDel)

	-- parental
	local btnParental = button:new(209, 0, buttonW, buttonH, Color.Blue, Color.Yellow)
	button:label(    btnParental, "Padres")
	button:textColor(btnParental, Color.White, Color.Black)
	button:icon(     btnParental, "imgs/Canales_Padres.png","imgs/Canales_Padres.png", 24, 20);
	button:action(   btnParental, "parentalPressed")
	wgt:setHelp(     btnParental, "Control parental: limita el acceso a contenidos no adecuados.\nOK = Editar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnParental, "disableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnParental)

	-- One-Seg
	local btnOneSeg = button:new(289, 0, buttonW, buttonH, Color.Blue, Color.Yellow)
	if (channels.showOneSeg() == TRUE) then
		button:label(btnOneSeg, "Ocultar")
		wgt:setHelp(btnOneSeg, "Oculta los canales One-Seg dentro de la lista de canales. \nOK = Ocultar    EXIT = Menú ppal.    MENU = Salir del menú")
	else
		button:label(btnOneSeg, "Mostrar")
		wgt:setHelp(btnOneSeg, "Muestra los canales One-Seg dentro de la lista de canales. \nOK = Mostrar    EXIT = Menú ppal.    MENU = Salir del menú")
	end
	button:textColor(btnOneSeg, Color.White, Color.Black)
	button:icon(     btnOneSeg, "imgs/Canales_One-Seg.png","imgs/Canales_One-Seg.png", 47, 20);
	button:action(   btnOneSeg, "onesegPressed")
	buttonset:addButton(Page_Channels.button_set, btnOneSeg)
	Page_Channels.btnOneSeg = btnOneSeg

	-- Scan
	local btnScan = button:new(354, 0, buttonW, buttonH, Color.Blue, Color.Yellow)
	button:label(    btnScan, "Buscar")
	button:textColor(btnScan, Color.White, Color.Black)
	button:icon(     btnScan, "imgs/Canales_Escanear.png","imgs/Canales_Escanear.png", 24, 20);
	button:action(   btnScan, "scanPressed")
	wgt:setHelp(     btnScan, "Busca y actualiza la lista de canales.\nOK = Buscar    EXIT = Menú ppal.    MENU = Salir del menú")
	button:selectedCallback(btnScan, "disableChannelList")
	buttonset:addButton(Page_Channels.button_set, btnScan)

-- Dialogs used in this page
	Page_Channels.pinRequired.dlg = alertdialog:new(PageX + (PageW - 385)/2,PageY + (PageH - 165)/2, 385,165, Color.Black, Color.Blue, PageBorder)
	alertdialog:title(   Page_Channels.pinRequired.dlg, "ADVERTENCIA")
	alertdialog:callback(Page_Channels.pinRequired.dlg, "closeDialog")
	alertdialog:text(    Page_Channels.pinRequired.dlg, "Debe establecer una clave en la pestaña CLAVE para habilitar esta opción. \n \n(OK = Volver)", 5)
	alertdialog:icon(    Page_Channels.pinRequired.dlg, "imgs/Confirmacion.png", 70,61, "imgs/Confirmacion_Gris.png")

	Page_Channels.confirmDelete.dlg = yesnodialog:new(PageX + (PageW - 421)/2,PageY + (PageH - 195)/2, 421,195, Color.Black, Color.Blue, PageBorder, 75,36)
	yesnodialog:title(    Page_Channels.confirmDelete.dlg, "ADVERTENCIA")
	yesnodialog:yesAction(Page_Channels.confirmDelete.dlg, "doDeleteChannel")
	yesnodialog:noAction( Page_Channels.confirmDelete.dlg, "closeDialog")
	yesnodialog:text(     Page_Channels.confirmDelete.dlg, "¿Está seguro que desea borrar el canal seleccionado?\nPara recuperarlo deberá actualizar la lista de canales con \"Buscar canales\".", 5);
	yesnodialog:icon(     Page_Channels.confirmDelete.dlg, "imgs/Confirmacion.png", 70,61, "imgs/Confirmacion_Gris.png")

	Page_Channels.confirmScan.dlg = yesnodialog:new(PageX + (PageW - 421)/2,PageY + (PageH - 195)/2, 421,195, Color.Black, Color.Blue, PageBorder, 75,36)
	yesnodialog:title(    Page_Channels.confirmScan.dlg, "ADVERTENCIA")
	yesnodialog:yesAction(Page_Channels.confirmScan.dlg, "scanConfirmed")
	yesnodialog:noAction( Page_Channels.confirmScan.dlg, "closeDialog")
	yesnodialog:text(     Page_Channels.confirmScan.dlg, "¿Está seguro que desea actualizar la lista de canales? Si lo hace, perderá las marcas de favoritos y bloqueados, y recuperará los canales borrados.", 5);
	yesnodialog:icon(     Page_Channels.confirmScan.dlg, "imgs/Confirmacion.png", 70,61, "imgs/Confirmacion_Gris.png")

	createScanningBanner()
	createParentalDialog()

	list:setValues(Page_Channels.channel_list, Page_Channels.visible_columns, Page_Channels.index_key, channels.getAll())
	
	return Page_Channels.page
end

function createScanningBanner()
	local x      = PageMargin + PageBorder
	local y      = PageH - buttonH - PageMargin - PageBorder
	local w      = PageW - 2*(PageMargin + PageBorder)
	local h      = buttonH 
	local innerx = PageBorder
	local innery = PageBorder
	local innerw = w - 2*PageBorder
	local innerh = h - 2*PageBorder

	Page_Channels.scanning_banner.window = window:new(x,y, w,h, Color.Black, Color.Yellow, PageBorder)
	Page_Channels.scanning_banner.text   = label:new(innerx + 10, innery + 5, innerw,26, "Buscando canales... ", 15, Color.White, Alignment.vTop_hLeft)
	window:addChild(Page_Channels.scanning_banner.window, Page_Channels.scanning_banner.text)

	local barFrame = window:new(innerx + 10, innery + 21, innerw - 20, 10, Color.DarkBlue)
	Page_Channels.scanning_banner.bar = bar:new(3, 3, innerw-26, 4, Color.White, -1, 0, 100)
	window:addChild(barFrame, Page_Channels.scanning_banner.bar)

	window:addChild(Page_Channels.scanning_banner.window, barFrame)

	menupage:addChild(Page_Channels.page, Page_Channels.scanning_banner.window)
	wgt:setVisible(Page_Channels.scanning_banner.window, FALSE)
end

function listMustIgnoreUpAndDownKeys(flag)
	wgt:ignoreKey(Page_Channels.channel_list, KEY_CURSOR_UP  , flag)
	wgt:ignoreKey(Page_Channels.channel_list, KEY_CURSOR_DOWN, flag)
end

function disableChannelList(focus)
	if focus == TRUE and list:selected(Page_Channels.channel_list) ~= -1 then
		listMustIgnoreUpAndDownKeys(TRUE)
		list:updateScrollbar(Page_Channels.channel_list, FALSE)
		lastChannelSelected = list:selected(Page_Channels.channel_list)
		list:setSelected(Page_Channels.channel_list, -1)
	end
end

function enableChannelList(focus)
	if focus == TRUE and list:selected(Page_Channels.channel_list) == -1 then
		list:updateScrollbar(Page_Channels.channel_list, TRUE)
		lastChannelSelected = math.min(lastChannelSelected, list:getRowCount(Page_Channels.channel_list)-1)
		list:setSelected(Page_Channels.channel_list, lastChannelSelected)
		listMustIgnoreUpAndDownKeys(FALSE)
	end
end

function Page_Channels.pinRequired.nav.processKeys(key)
	return wgt:processKey(Page_Channels.pinRequired.dlg, key)
end

function Page_Channels.confirmDelete.nav.processKeys(key)
	return wgt:processKey(Page_Channels.confirmDelete.dlg, key)
end

function Page_Channels.confirmScan.nav.processKeys(key)
	return wgt:processKey(Page_Channels.confirmScan.dlg, key)
end

function selectedChannelID()
	return list:getCurrentValue(Page_Channels.channel_list)
end

function selectedIndex()
	return list:selected(Page_Channels.channel_list)
end

function toggleFlag(f)
	local id = selectedChannelID()
	f(id)
	local changedChannel = channels.get(id)
	list:updateRow(Page_Channels.channel_list, selectedIndex(), Page_Channels.visible_columns, Page_Channels.index_key, changedChannel)
end

---------------------------------------------------------------------------------------------------
-- Favourite button
---------------------------------------------------------------------------------------------------

function favPressed()
	if channels.count() > 0 then
		toggleFlag(channels.toggleFavorite)
	end
end

---------------------------------------------------------------------------------------------------
-- Block button
---------------------------------------------------------------------------------------------------

function bloqPressed()
	if channels.count() > 0 then
		if PINSet() then
			MainMenu.PINDlg.open(doBlockChannel)
		else
			openDialog(Page_Channels.pinRequired)
		end
	end
end

function doBlockChannel()
	toggleFlag(channels.toggleBlocked)
end

function unblockChannels()
	channels.unblockAll()
	list:setValues(Page_Channels.channel_list, Page_Channels.visible_columns, Page_Channels.index_key, channels.getAll())
end

---------------------------------------------------------------------------------------------------
-- Delete button
---------------------------------------------------------------------------------------------------

function delPressed()
	if channels.count() > 0 then
		openDialog(Page_Channels.confirmDelete)
 	end
end

function doDeleteChannel()
	if channels.count() > 0 then -- warn only when there are channels
		closeDialog(Page_Channels.confirmDelete)
	end
	channelDeleted(tonumber(selectedChannelID())) -- tell the chs.lua module
	channels.remove(selectedChannelID())
	local size = #channels.getAll()
	if list:selected(Page_Channels.channel_list) == size and size ~= 0 then
		list:setSelected(Page_Channels.channel_list, size-1)
	end
	list:setValues(Page_Channels.channel_list, Page_Channels.visible_columns, Page_Channels.index_key, channels.getAll())
	if size == 0 then
--		print("[lua] player.showSplashScreen()")
		list:setSelected(Page_Channels.channel_list, -1)
		player.showSplashScreen()
	end
end

---------------------------------------------------------------------------------------------------
-- Parental button
---------------------------------------------------------------------------------------------------

function parentalPressed()
	if PINSet() then
		ParentalDialog.open()
	else
		openDialog(Page_Channels.pinRequired)
	end
end

---------------------------------------------------------------------------------------------------
-- Scan button
---------------------------------------------------------------------------------------------------

function scanPressed()
	if channels.count() > 0 then -- warn only when there are channels
		openDialog(Page_Channels.confirmScan)
	else
		scanConfirmed()
	end	
end

function scanConfirmed()
	if channels.count() > 0 then -- warn only when there are channels
		closeDialog(Page_Channels.confirmScan)
	end
	if PINSet() then
		MainMenu.PINDlg.open(doScanChannels)
	else
		doScanChannels()
	end
end

function Page_Channels.scanning_banner.update(net)
	if (net ~= '') then
		Page_Channels.scanning_banner.net = net
	end
	local perc = math.floor(100 * math.min(1.0, Page_Channels.scanning_banner.CurrentNetwork/Page_Channels.scanning_banner.NetworkCount))
	local text = 'Buscando canales... '.. perc ..'% ('.. Page_Channels.scanning_banner.net ..'Mhz)'..'  -  '.. channels.count() ..' encontrados'
	
	label:setText(Page_Channels.scanning_banner.text, text)
	bar:setValue(Page_Channels.scanning_banner.bar, perc)
	wgt:setVisible(Page_Channels.button_set, FALSE)
	wgt:setVisible(Page_Channels.scanning_banner.window, TRUE)
end

function doScanChannels()
	Page_Channels.scanning = true
	wgt:setVisible(Page_Channels.scanning_banner.window, TRUE)

	list:updateScrollbar(Page_Channels.channel_list, TRUE)
	list:setValues(Page_Channels.channel_list, Page_Channels.visible_columns, Page_Channels.index_key, {})
	list:setSelected(Page_Channels.channel_list, -1)

	Page_Channels.scanning_banner.update('')

	tuner.startScan()
end

function Page_Channels.beginScan( networks )
	print( "[lua] Begin scan of " .. networks .. " networks" )
	Page_Channels.scanning_banner.NetworkCount   = networks
	Page_Channels.scanning_banner.CurrentNetwork = 0
	player.showSplashScreen()
end

function Page_Channels.scanNetwork( net )
	print( "[lua] Begin network scan: freq= " .. net )
	Page_Channels.scanning_banner.CurrentNetwork = Page_Channels.scanning_banner.CurrentNetwork + 1
	Page_Channels.scanning_banner.update(net)
end

function Page_Channels.programFound( ch )
	print( "[lua] Page_Channels.programFound: " .. ch['name'] )
	list:addRow(Page_Channels.channel_list, Page_Channels.visible_columns, Page_Channels.index_key, ch)
	Page_Channels.scanning_banner.update('')
end

function Page_Channels.endScan()
	print( "[lua] Page_Channels.endScan" )
	Page_Channels.scanning = false
	wgt:setVisible(Page_Channels.scanning_banner.window, FALSE)
	wgt:setVisible(Page_Channels.button_set, TRUE)
	ignoreAllKeys(false)
end

---------------------------------------------------------------------------------------------------
-- One-seg button
---------------------------------------------------------------------------------------------------

function onesegPressed()
	local ShowOneSeg = channels.toggleOneSeg()

	if (ShowOneSeg == TRUE) then
		button:label(Page_Channels.btnOneSeg, "Ocultar")
		wgt:setHelp(Page_Channels.btnOneSeg, "Oculta los canales One-Seg dentro de la lista de canales. \nOK = Ocultar    EXIT = Menú ppal.    MENU = Salir del menú")
	else
		button:label(Page_Channels.btnOneSeg, "Mostrar")
		wgt:setHelp(Page_Channels.btnOneSeg, "Muestra los canales One-Seg dentro de la lista de canales. \nOK = Mostrar    EXIT = Menú ppal.    MENU = Salir del menú")
	end
	wgt:repaint(Page_Channels.btnOneSeg)
	list:updateScrollbar(Page_Channels.channel_list, TRUE)
	lastChannelSelected = 0
	list:setValues(Page_Channels.channel_list, Page_Channels.visible_columns, Page_Channels.index_key, channels.getAll())
	list:setSelected(Page_Channels.channel_list, -1)
end

function chooseFlagsImages( ch )
	local bn,bs = " ", " "
	local fn,fs = " ", " "
	if (ch["blocked"] == 1) then
		bs = "img:imgs/Canales_Bloquear.png"
		bn = "img:imgs/Canales_Bloquear_Blanco.png"
	end
	if (ch["favorite"] == 1) then
		fs = "img:imgs/Canales_Favorito.png"
		fn = "img:imgs/Canales_Favorito_Blanco.png"
	end
	
	return bn,bs,fn,fs
end

function Page_Channels.currentHelp()
	if (menupage:isActive(Page_Channels.page)==0) then
		return Page_Channels.help
	else
		return wgt:getHelp(Page_Channels.button_set)
	end
end

function Page_Channels.processKeys(key)
	print('[lua] Page_Channels.processKeys('.. key ..')')
	local ret = true

	if Page_Channels.scanning and key ~= KEY_EXIT then
		print('[lua] Page_Channels.processKeys(), ignoring')
		return true
	end

	if wgt:processKey(Page_Channels.button_set, key) == 0 then
		if wgt:processKey(Page_Channels.channel_list, key) == 0 then
			return pkey(Page_Channels, key)
		end
	end

	MainMenu.updateHelp(Page_Channels)

	return ret
end

function Page_Channels.onExit()
	if Page_Channels.scanning then
		ignoreAllKeys(true)
		tuner.stopScan()
		--menupage:setActive(Page_Channels.page, TRUE)
		return true
	end
	return false		
end

function Page_Channels.activate(b)
	if (b) then
		enableChannelList(TRUE)
		lastChannelSelected = 0
		list:setSelected(Page_Channels.channel_list, -1)
		buttonset:setActiveButton(Page_Channels.button_set, 0)
		menupage:setActive(Page_Channels.page, TRUE)
	else
		list:setSelected(Page_Channels.channel_list, -1)
		buttonset:setActiveButton(Page_Channels.button_set, -1)
		menupage:setActive(Page_Channels.page, FALSE)
	end
end

function Page_Channels.select(b)
	if (b) then
		list:setSelected(Page_Channels.channel_list, -1)
	end
end
	

