local VolumeVisible = false

local volumeBar = window:new(160, 412, 400, 27, Color.Blue)
local title = label:new(14, 0, 50, 27, "Volumen", 16, Color.White, Alignment.vCenter_hLeft)
local valueL = label:new(0, 0, 390, 27, "", 16, Color.White, Alignment.vCenter_hRight)
local barBackground = window:new(100, 4, 263, 19, Color.DarkBlue)
local vBar = bar:new(100 + 3, 4 + 3, 263 - 3*2, 19 - 3*2, Color.White, -1, 0, 20)
window:addChild(volumeBar, title)
window:addChild(volumeBar, valueL)
window:addChild(volumeBar, barBackground)
window:addChild(volumeBar, vBar)
wgt:fixOffsets(volumeBar)
wgt:setVisible(volumeBar, FALSE)


local MUTE_X, MUTE_Y, MUTE_W, MUTE_H = 72, 57, 47, 38
local mute = image:new(MUTE_X, MUTE_Y, MUTE_W, MUTE_H, "imgs/Mute.png")
wgt:setVisible(mute, FALSE)


function renderVolume()
	print("[lua] renderVolume.....................")
	local barW, barH = 400,26
      
  	if(not VolumeVisible) then
		openVolumeNav()
  	end
	local value = player.getVolume()
	bar:setValue(vBar, value)
	label:setText(valueL, value)
	wgt:open(volumeBar)

	VolumeVisible = true
	mainWindow.registerTimer(Timers['volume']['id'], Timers['volume']['timeout'])
end

local MuteVisible = false

function clearMute()
	print('[lua] clearMute()...............')
	if MuteVisible then
		MuteVisible = false
		closeMuteNav()
		wgt:close(mute)
	end
end

function renderMute( isMuted )
	print("[lua] renderMute.............")
	if isMuted == TRUE then
		MuteVisible = true
		openMuteNav()
		wgt:open(mute)
	else
		clearMute()
		renderVolume()
	end
end

function clearVolume()
	if (VolumeVisible) then
		wgt:close(volumeBar)
		mainWindow.cancelTimer(Timers.volume.id)
		VolumeVisible = false
		closeVolumeNav()
	end
end

function toggleMute()
	clearVolume()
	renderMute( player.toggleMute() )
end

function volumeUp()
	if (VolumeVisible) then
		player.volumeUp()
		renderVolume()
	elseif (player.isMuted() == 1) then
		toggleMute()
	else
		renderVolume()
	end
end

function volumeDown()
	if (VolumeVisible) then
		player.volumeDown()
		renderVolume()
	elseif (player.isMuted() == 1) then
		toggleMute()
	else
		renderVolume()
	end
end

-----------------------------------------------------------------------------------

VolumeNav = {
	  name = "VolumeNav"
	, close = clearVolume
}

function VolumeNav.processKeys(key)
	print('[lua] VolumeNav.processKeys('.. key ..')')
	return pkey(VolumeNav, key)
end

function VolumeNav.onVolUp()
	volumeUp()
	return true
end

function VolumeNav.onVolDown()
	volumeDown()
	return true
end


function VolumeNav.onDown()
	if not ApplicationRunning then
		closeCurrentWindow()
		channelDown( true )
	end
	return true
end

function VolumeNav.onUp()
	if not ApplicationRunning then
		closeCurrentWindow()
		channelUp( true )
	end
	return true
end


function openVolumeNav()
	print('[lua] openVolumeNav()')
	pushCurrentWindow(VolumeNav)
end

function closeVolumeNav()
	print('[lua] closeVolumeNav()')
	popCurrentWindow()
end

-----------------------------------------------------------------------------------

MuteNav = {
	  name = "MuteNav"
	, close = clearMute
}

function MuteNav.processKeys(key)
	return pkey(MuteNav, key)
end

function MuteNav.onVolUp()
	closeToRoot()
	volumeUp()
	return true
end

function MuteNav.onVolDown()
	closeToRoot()
	volumeDown()
	return true
end

function MuteNav.onMute()
	closeToRoot()
	toggleMute()
	return true
end

function openMuteNav()
	print('[lua] openMuteNav()')
	pushCurrentWindow(MuteNav)
end

function closeMuteNav()
	print('[lua] closeMuteNav()')
	popCurrentWindow()
end


